// cBmp.hpp

class cBmp;

#import "math3d.h"
class cVector;


class cBmp {
  public:
  INTEG         mBPP;
  INTEG         mWidth;
  INTEG         mHeight;
  BYTE         *mBmp;
  public:
                cBmp();
  void          Resize(INTEG width, INTEG height, INTEG bpp);
  BOOLEAN       Inside(INTEG x, INTEG y);
  BOOLEAN       LoadTga(char *fname);
  void          MakeAlpha(cVector alphaColor);
  void          SetPixel(INTEG x, INTEG y, INTEG z, BYTE c);
  BYTE          GetPixel(INTEG x, INTEG y, INTEG z);
  void          Clear(INTEG z, BYTE c);
  void          Clear(INTEG x, INTEG y, INTEG z, INTEG w, INTEG h, BYTE c);
  void          CopyLayer(cBmp *srcBmp, INTEG srcZ, INTEG dstZ);
  void          Plasma(INTEG x, INTEG y, INTEG z, INTEG w, INTEG h, BYTE c);
  void          Add(INTEG z, BYTE c);
  void          Mul(INTEG z, SCALAR m);
  void          Mul(INTEG z, BYTE m);
  void          Div(INTEG z, SCALAR d);
  void          Div(INTEG z, BYTE d);
  BOOLEAN       glUpload(WORD id);
  BOOLEAN       glRegister(BOOLEAN mipmap, WORD &id);
};


