// cParticle.cpp
//
// Copyright (c) 1999 by B.Pickhardt (pickhardt@debitel.net).
//

#import "cParticle.hpp"

#import "cVector.hpp"
#import "cMatrix.hpp"

#ifdef _WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <GL\gl.h>
#include <GL\glu.h>
#else
#include <GL/gl.h>
#include <GL/glu.h>
#endif


void cParticle::Draw(cMatrix camera, cVector facing, SCALAR size)
{
  cMatrix cm;
  cm.RotXYZ(facing.mV[X], facing.mV[Y], facing.mV[Z]);
  cm.MovRel(mPosition.mV[X], mPosition.mV[Y], mPosition.mV[Z]);
  cm.Mul(camera);
  glLoadMatrixf(cm.mM);
  SCALAR a = -size / 2;
  SCALAR b = +size / 2;
  glBegin(GL_QUADS);
    glTexCoord2f(0.0, 0.0);
    glVertex3f(a, a, 0.0);
    glTexCoord2f(1.0, 0.0);
    glVertex3f(b, a, 0.0);
    glTexCoord2f(1.0, 1.0);
    glVertex3f(b, b, 0.0);
    glTexCoord2f(0.0, 1);
    glVertex3f(a, b, 0.0);
  glEnd();
}

