// cSprite.hpp
//
// Stuff for a 3d engine.
// Copyright (c) 1999 by B.Pickhardt (pickhardt@debitel.net).
// aka hackCraft
//

class cSprite;

#import "math3d.h"
#import "cVector.hpp"
#import "cBody.hpp"


struct cRawPolygon {
  INTEG               mSide;
  INTEG               mPnt[3];
};


class cSprite {
  public:
  WORD                mTexture[2];
  INTEG               mNPnt;
  INTEG               mNPlg;
  INTEG              *mLmb;
  cVector            *mTex;
  cVector            *mPnt;
  cRawPolygon        *mPlg;
  cRawPolygon         mSel;
  cBody              *mBody;
  public:
                      cSprite();
  void                Save(char *fname);
  void                Load(char *fname);
  void                GetMem(INTEG pnt, INTEG plg);
  void                Draw(cMatrix camera);
  void                Draw();
  void                DrawFront();
  void                DrawBack();
  void                DragFront(cVector pos);
  void                DragBack(cVector pos);
  void                PushFront(cVector pos, SCALAR offset);
  void                PushBack(cVector pos, SCALAR offset);
  INTEG               SelectFront(cVector center);
  INTEG               SelectBack(cVector center);
  void                AddFrontPoly(cVector center);
  void                AddBackPoly(cVector center);
  void                MarkFrontLimb(INTEG lmb);
  void                MarkBackLimb(INTEG lmb);
};


