// cObject.hpp

#include "cObject.h"

cObject::cObject()
{
  //printf("cObject::cObject()\n");
    
  // BASE
  mWorld = NULL;
  mFragged = false;
  mRoles = 0;

  // NAMEABLE
  mName = new string("Anonymous");
  mDescription = new string("Undescribed");
  mDesignation = 0;
  
  // SOCIAL
  mAllies = 0;
  mEnemies = 0;
  
  // TRACKABLE
  mPos[0] = mPos[1] = mPos[2] = 0.0f;
  mRot[0] = mRot[1] = mRot[2] = 0.0f;
  mRadius = 1;
  
  // DAMAGEABLE
  mHp = NULL;
  //mSplasharmor = NULL;
  //mBeamarmor = NULL;
  //mPiercearmor = NULL;
  
  // ENTITY
  mTarget = NULL;
  mPad = NULL;
  mController = NULL;
  mModel = NULL;
}


cObject::cObject(cObject* source)
{
  //printf("cObject::cObject(cObject*)\n");

  // BASE
  mWorld = NULL;
  mFragged = source->mFragged;
  mRoles = source->mRoles;
  
  // NAMEABLE
  mName = source->mName;
  mDesignation = source->mDesignation;
  
  // SOCIAL
  mAllies = source->mAllies;
  mEnemies = source->mEnemies;
  
  // TRACKABLE
  memcpy(mPos, source->mPos, sizeof(float) * 3);
  memcpy(mRot, source->mRot, sizeof(float));
  mRadius = source->mRadius;
  
  // DAMAGEABLE
  mHp = source->mHp;
  //mSplasharmor = source->mSplasharmor;
  //mBeamarmor = source->mBeamarmor;
  //mPiercearmor = source->mPiercearmor;
  
  // ENTITY
  mTarget = source->mTarget;
  mPad = source->mPad;
  mController = source->mController;
  mModel = source->mModel;
}


