//
// File:   cWeapon.h
// Author: hackCraft
//
// Created on March 5, 2008, 4:09 PM
//

#ifndef _CWEAPON_H
#define	_CWEAPON_H

#include <list>
using namespace std;

class cWorld;
class cObject;

class cWeapon {
public:
    
    // World the Weapon may damage.
    cWorld* mWorld;
    
    // Points To Current Vehicle Base Matrix.
    float* mBasefv;
    
    // Mounting Base Matrix relative to Vehicle Base Matrix.
    float* mMountfv;
    
    // Remaining reload time until next firing is possible.
    float mReloading;
    
public:
    cWeapon();
    //cWeapon(cWeapon *source);
    
    virtual void fireSelf(cObject *target) = 0;
    virtual void animateSelf(float spf) {};
    virtual void transformSelf() {}
    virtual void drawSelf() {}
    virtual void drawEffect() {}
};


class cMachineGun : public cWeapon {
protected:
    struct Shrapnel {
        float pos[3];
        float vel[3];
        float cnt;
    };
    list<Shrapnel*> shrapnels;
    
public:
    cMachineGun() {};
    //cMachineGun(cMachineGun *source);
    
    virtual void fireSelf(cObject *target);
    virtual void animateSelf(float spf);
    virtual void drawSelf() {};
    virtual void drawEffect();
};


class cPlasmaGun : public cWeapon {
protected:
    struct Shrapnel {
        float pos[3];
        float vel[3];
        float cnt;
    };
    list<Shrapnel*> shrapnels;
    
public:
    cPlasmaGun() {};
    //cPlasmaGun(cPlasmaGun *source);
    
    virtual void fireSelf(cObject *target);
    virtual void animateSelf(float spf);
    virtual void drawSelf() {};
    virtual void drawEffect();
};


class cSparkGun : public cWeapon {
protected:
    struct Shrapnel {
        float pos[3];
        float vel[3];
        float cnt;
    };
    list<Shrapnel*> shrapnels;
    
public:
    cSparkGun() {};
    //cSparkGun(cSparkGun *source);
    
    virtual void fireSelf(cObject *target);
    virtual void animateSelf(float spf);
    virtual void drawSelf() {};
    virtual void drawEffect();
};


class cRaybeam : public cWeapon {
protected:
    float raylife;

public:
    cRaybeam() : raylife(0) {};
    
    virtual void fireSelf(cObject *target);
    virtual void animateSelf(float spf);
    virtual void drawSelf();
    virtual void drawEffect();
};


#endif	/* _CWEAPON_H */

