// main.hpp

#if !defined(MAIN_INC)
#define MAIN_INC

#ifdef _WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <unistd.h>
#else
//#include <io.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>

#include <fcntl.h>
//#include <time.h>

#include <ctime>
#include <list>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <string.h>
#include <cassert>

using namespace std;

#ifndef M_PI
#define M_PI 3.141594
#endif

#include "psi3d/psi3d.h"

#include "userkeys.h"

#undef xmod
#undef xabs
#undef distance


void setupMatrix(float *mat, float *rot = NULL, float *pos = NULL);
void setupInvMatrix(float *mat, float *rot = NULL, float *pos = NULL);


//-----------------------------------

#include "cPad.h"
#include "cController.h"

#include "cDome.h"

#include "cWorld.h"
#include "cObject.h"
#include "cWeapon.h"
#include "cModel.h"
#include "cEntityModel.h"

#include "models.h"
#include "entities.h"


#endif
